package com.fr.plugin.xx.theme.sky;

import com.fr.decision.fun.impl.AbstractThemeVariousProvider;
import com.fr.decision.web.MainComponent;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.locale.InterProviderFactory;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.fun.Authorize;
import com.fr.stable.version.ProductVersion;
import com.fr.stable.version.ProductVersionManager;
import com.fr.web.struct.Atom;

import java.util.List;

/**
 * @author k
 * @Project name starter
 * @description:
 * @created on 2019/10/24 22:13.
 * @email xx.xx@qq.com
 * @Modified By
 */
@FunctionRecorder
@Authorize(callSignKey = Constants.PLUGIN_ID)
@EnableMetrics
public class SkyTheme extends AbstractThemeVariousProvider {

	@Override
	public Atom attach() {
		return MainComponent.KEY;
	}

	@Override
	@Focus(id = Constants.PLUGIN_ID, text = "Sky Theme", source = Original.PLUGIN)
	public Atom client() {
		return SkyComponent.KEY;
	}

	@Override
	public String name() {
		return InterProviderFactory.getProvider().getLocText("FS-THEME-SKY-TITLE");
	}

	@Override
	public String text() {
		return InterProviderFactory.getProvider().getLocText("FS-THEME-SKY-TITLE");
	}

	@Override
	public String coverPath() {
		return "com/fr/plugin/xx/theme/sky/resource/cover.png";
	}

}