package com.fr.plugin.xx.theme.sky.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;

@Visualization(category = "天空主题扩展配置")
public class SkyThemeConfig extends DefaultConfiguration {
    private static volatile SkyThemeConfig config = null;

    public static SkyThemeConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(SkyThemeConfig.class);
        }
        return config;
    }

    @Identifier(value = "isOpen", name = "开起扩展配置", description = "开起后刷新生效", status = Status.HIDE, group = "core")
    private Conf<Boolean> isOpen = Holders.simple(true);


    @Identifier(value = "", name = "", description = "", status = Status.HIDE, group = "core")
    private Conf<String> test = Holders.simple("");


    @Identifier(value = "logoFontSize", name = "Logo字体大小", description = "", status = Status.SHOW, group = "logo")
    private Conf<Double> logoFontSize = Holders.simple(16D);


    @Identifier(value = "logoFontColor", name = "Logo字体颜色", description = "请使用#FFFFFF或rgb(255,255,255)", status = Status.SHOW, group = "logo")
    private Conf<String> logoFontColor = Holders.simple("#FFFFFF");


    @Identifier(value = "navFontSize", name = "导航字体大小", description = "", status = Status.SHOW, group = "nav")
    private Conf<Integer> navFontSize = Holders.simple(12);


    @Identifier(value = "navFontColor", name = "导航字体颜色", description = "请使用#FFFFFF或rgb(255,255,255)", status = Status.SHOW, group = "nav")
    private Conf<String> navFontColor = Holders.simple("#FFFFFF");


    @Identifier(value = "topFontSize", name = "顶部字体大小", description = "", status = Status.SHOW, group = "top")
    private Conf<Integer> topFontSize = Holders.simple(13);


    @Identifier(value = "topFontColor", name = "顶部字体颜色", description = "请使用#FFFFFF或rgb(255,255,255)", status = Status.SHOW, group = "top")
    private Conf<String> topFontColor = Holders.simple("#FFFFFF");


    @Identifier(value = "childMenuFontSize", name = "子菜单字体大小", description = "", status = Status.SHOW, group = "child")
    private Conf<Integer> childMenuFontSize = Holders.simple(14);


    @Identifier(value = "childMenuFontColor", name = "子菜单字体颜色", description = "请使用#FFFFFF或rgb(255,255,255)", status = Status.HIDE, group = "child")
    private Conf<String> childMenuFontColor = Holders.simple("#3d4d66");


    @Identifier(value = "menuWidth", name = "左侧菜单宽度", description = "", status = Status.SHOW, group = "leftMenu")
    private Conf<Integer> leftMenuWidth = Holders.simple(240);

    @Identifier(value = "menuMarginColor", name = "菜单间隔颜色", description = "请使用#FFFFFF或rgb(255,255,255)", status = Status.SHOW, group = "leftMenu")
    private Conf<String> leftMenuColor = Holders.simple("#c1c1c1");

    public Boolean getIsOpen() {
        return isOpen.get();
    }

    public Double getLogoFontSize() {
        return logoFontSize.get();
    }

    public String getLogoFontColor() {
        return logoFontColor.get();
    }

    public Integer getNavFontSize() {
        return navFontSize.get();
    }

    public String getNavFontColor() {
        return navFontColor.get();
    }

    public Integer getTopFontSize() {
        return topFontSize.get();
    }

    public String getTopFontColor() {
        return topFontColor.get();
    }

    public Integer getChildMenuFontSize() {
        return childMenuFontSize.get();
    }

    public String getChildMenuFontColor() {
        return childMenuFontColor.get();
    }

    public Integer getLeftMenuWidth() {
        return leftMenuWidth.get();
    }


    public String getLeftMenuColor() {
        return leftMenuColor.get();
    }


    @Override
    public String getNameSpace() {
        return "SkyThemeConfig";
    }
}
